// bkdoc.cpp : implementation of the CBkDoc class
#include "stdafx.h"
#include "bk.h"
#include "bkdoc.h"
//#include "Eurosmartdx.h"
//#include "Candibusdx.h"

#include "Eurosmart.h"
#include "Candibus.h"


#include <conio.h>
#include <sys/timeb.h>
#include <dos.h>
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDoc construction/destruction
CBkDoc::CBkDoc()
{
	//Rgression linaire
	m_pDMC=new CDMC();
	
  //Dclaration de 2 tableaux dynamiques contenant les acq.
  m_iNbAcq=2048;		//2048 acq. maxi   0
  m_iNbA=0;					//Aucune acquisition de faite pour l'instant
  m_iNbL=0;
  m_fT=new float[m_iNbAcq][4];//[0]:N pt, [1]: UAir, [2]:AngleLame, [3]:ULame
  if (m_fT==NULL)
  {
  	AfxMessageBox("Erreur de cration tableau dynamique");
  }
  //Initialisation du tableau
  for (int i=0;i<4;i++)
  {
  	for (int j=0;j<m_iNbAcq;j++)
  	{
  		m_fT[j][i]=1e10;
  	}
  }          
  //Initialisation tableau position des franges
  for (i=0;i<100;i++)
  {
  	for (int j=0;j<2;j++)
  	{
  		m_iTfr[j][i]=9999;
  	}
  }          
	//Type de graphe par dfaut
	m_iTypeGr=0;	//Indice de l'air
  m_iAxe_abs=0;
  m_iAxe_ord=2;
	//Mesure de l'indice de l'air
	m_fP1=0.430;
	m_fP2=1.013;
	m_iNbPts=1024;
	m_iNbFr=14;
	m_fLambda=632.8;	//Mme var. pour paisseur lame
	m_fLg=50; 
	m_fFrPart=0;			//Franges partielles mises  zro par dfaut le 06/10/03
	m_iTempo=5;				//Tempo entre les acquisitions en ms
  //Variables pour mesure de l'paisseur de la lame
 	m_fAng=20;
  m_fVit=360;
  m_fIndice=1.5;
  m_fEpais=3;
  m_iNbFr1=22;    
  m_fAlpha0=-0.0523;
  m_fU0=2.991;       
  m_fAlpha1=29.237;
  m_fAlpha2=-29.491;
  m_fUmax=3.873;			//Tensions au voisinage du centre
  m_fUmin=0.0164;       
 	m_iFrCentre=1; 			//Frange partielle 0:claire, 1:sombre
	m_fFrPart1=0;
	//Dimensions initiales: imprimante
	m_fLarg=280;
	m_fHaut=195;
	//Fentre graphique
	m_fXmi=-m_fLarg/2;
	m_fYmi=-m_fHaut/2;
	m_fXma=m_fLarg/2;
	m_fYma=m_fHaut/2;
	//Dcalage d'origine, chelles et facteurs d'chelle
	m_fXori=0;
	m_fYori=0;
	m_fEchx=1;
	m_fEchy=1;
	m_fFactx=1;
	m_fFacty=1; 
	 
	m_sNomFic="SansNom.mac";			//Nom du fichier par dfaut
	m_sNomFicTxt="SansNom.txt";	//Nom du fichier compatible Excel
	//Infos zone de liste
	m_OKinfo=TRUE; 						//Affichage des infos par dfaut
	m_sTab.RemoveAll();
	CTime t =CTime::GetCurrentTime();   
	//Voir strftime pour spcificateurs de format ...
	CString s = t.Format("%d/%m/%y - %H:%M" );
  //char s[80];
	m_sTab.Add("MACH-ZEHNDER");
	//m_sTab.Add("TS2PH-TPMO N8");
	m_sTab.Add(s);
	m_sTab.Add("Nom(s)/Prnom(s):");
	m_fXinfo=80;							//Position d'criture par dfaut
	m_fYinfo=90;
	//Souris
	m_bOKSou=FALSE;           //Bote de dialogue souris non affiche
	//DMC                     
	m_bOKDmc=FALSE;						//Bote de dialogue DMC non affiche 
	//Paramtres carte A/N pour acq. franges
  m_iNoVoie[0]=0;						//Voie 0 par dfaut
  m_iMoy[0]=256;						//Moyennage sur 256 valeurs pour chaque acq.
	//Paramtres carte A/N pour acq. pression
  m_iNoVoie[1]=1;						//Voie 0 par dfaut
  m_iMoy[1]=256;						//Moyennage sur 12 valeurs pour chaque acq.
  //Mesure pression
  m_faP=0.189;              //Pente
  //m_fbP=-0.153;							//Ordonne origine
  m_fbP=-0.168;							//Ordonne origine
	//Pas de digitalisation active
  m_iNoBtn=-1;

	//Nom de fichier sur ligne de commande
  CWinApp *p=AfxGetApp();
	CString s2=p->m_lpCmdLine;
	s2.MakeLower();
	if (s2.Right(4)==".mac") 
	{
		m_sNomFic=s2;   
		//Lecture du fichier .mac
		OnOpenDocument(s2);
  }
	//Rajout le 01/07/03: Dtection automatique carte A/N
	class CEurosmart* pEuro;
	pEuro=new CEurosmart();
	class CCandibus* pCand;
	pCand=new CCandibus();
	float u,u1;
	
	//On lit la tension sur les cartes
	u=pEuro->LitTension(0,0,2);
	u1=pCand->LitTension(0,2);

	if (u==1e10 && u1==1e10)
	{
		/*
		if (AfxMessageBox("AUCUNE carte A/N dtecte !\nSi une carte est prsente, installer sous une session ADMINISTRATEUR le logiciel :\nPort I/O Driver (port95nt.exe) ...\n\nDsirez-vous le tlcharger ?",MB_YESNO)==IDYES)
		{
			CString s="C:\\Program Files\\Internet Explorer\\IEXPLORE.EXE";
			CString s1="http://gop.mermoz.free.fr/visuim/port95nt.exe";
			HINSTANCE er;
			short er1;
			er=ShellExecute(NULL,"open",s,s1,"",SW_SHOWMAXIMIZED);
			er1=(short)er;
			if (er1<=32)
			AfxMessageBox("Le logiciel est disponible sous :\nhttp://gop.mermoz.free.fr/visuim"); 
		}
		*/
		AfxMessageBox("Aucune carte A/N dtecte !");
		m_iTypeCarte=-1;
		m_iTypePol[0]=1;
		m_iTypePol[1]=1;
	}
	else
	if (u!=1e10)
	{
		//Eurosmart
		AfxMessageBox("Carte Eurosmart dtecte.");
		m_iTypeCarte=0;
		m_iTypePol[0]=1;	//Franges: bipolaire                   
		m_iTypePol[1]=0;	//Pression: unipolaire
	}
	else
	{
		//Candibus
		AfxMessageBox("Carte Candibus dtecte.");
		m_iTypeCarte=1;
		m_iTypePol[0]=1;	//Uniquement bipolaire
		m_iTypePol[1]=1;
	}
	delete pCand;delete pEuro;
}
//________________________________________
CBkDoc::~CBkDoc()
{
  //Libration mmoire tableaux de valeurs dynamiques
	delete[] m_fT;
	//Suppression pointeurs sur classes
	delete m_pDMC;
}
//________________________________________
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	CString s;
  //Suppression extension
  s=m_sNomFic.Mid(0,m_sNomFic.GetLength()-4);
  //Suppression chemin
  int i=s.GetLength();
  do
  {    
  	i--;
  }
  while (i>=0 && s.GetAt(i)!='\\' && s.GetAt(i)!=':');
  if (i!=0) s=s.Mid(i+1,s.GetLength());
	//En minuscules
	s.MakeLower();
	//1er caractre en majuscules
	s.SetAt(0,toupper(s.GetAt(0)));	
	SetTitle(s);
	return TRUE;
}
//________________________________________
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	short i,j;         
	CString s,s1,s2; 

	if (ar.IsStoring())
	{
		//Ecriture
		//Carte A/N 
		for (i=0;i<2;i++)
		{
			ar << (WORD)m_iNoVoie[i];
			ar << (WORD)m_iTypePol[i];
			ar << (WORD)m_iMoy[i];
		}
		//Carte C832
		
		//Type graphe
		ar << (WORD)m_iTypeGr;
		ar << (WORD)m_iAxe_abs;
		ar << (WORD)m_iAxe_ord;
		//Indice air
		ar << m_fP1;
		ar << m_fP2;
		ar << (WORD)m_iNbPts;
		ar << (WORD)m_iNbFr;
		ar << m_fLambda;
		ar << m_fLg;
		ar << m_fFrPart;
    //Indice/Epais. lame
	 	ar << m_fAng;
  	ar << m_fVit;
  	ar << m_fIndice;
  	ar << m_fEpais;
  	ar << (WORD)m_iNbFr1;    
  	ar << m_fAlpha0;
  	ar << m_fU0;       
  	ar << m_fAlpha1;
  	ar << m_fAlpha2;
  	ar << m_fUmax;       
  	ar << m_fUmin;       
 		ar << (WORD)m_iFrCentre;  
		ar << m_fFrPart1;
		//Pression
		ar << m_faP;
		ar << m_fbP;
    //Mesures
		ar << (WORD)m_iNbA;           
		ar << (WORD)m_iNbL;           
		for (i=0;i<m_iNbAcq;i++)
		{
			for (j=0;j<4;j++)
			{
				ar << m_fT[i][j];
			}
		}                    
		//Srialisation infos
		ar << (WORD)m_sTab.GetSize();
		for (i=0;i<m_sTab.GetSize();i++)
		{  
			ar << m_sTab.GetAt(i);
		}
		ar << m_fXinfo;
		ar << m_fYinfo;
	}
	else
	{
		//Lecture   
		//Initialisation paramtres DMC
		for (i=0;i<3;i++)
		{
    	m_pDMC->m_OKCalcul[i]=FALSE;//Pas de DMC calcule
    }
    //Pas de maxis calculs
	  for (i=0;i<100;i++)
 		{
			m_iTfr[0][i]=9999;
			m_iTfr[1][i]=9999;
 		}          
		//Carte A/N          
		for (i=0;i<2;i++)
		{
			ar >> (WORD&)m_iNoVoie[i];
			ar >> (WORD&)m_iTypePol[i];
			ar >> (WORD&)m_iMoy[i];
    }
    
		//Type graphe
		ar >> (WORD&)m_iTypeGr;
		ar >> (WORD&)m_iAxe_abs;
		ar >> (WORD&)m_iAxe_ord;
		//Indice air
		ar >> m_fP1;
		ar >> m_fP2;
		ar >> (WORD&)m_iNbPts;
		ar >> (WORD&)m_iNbFr;
		ar >> m_fLambda;
		ar >> m_fLg;
  	ar >> m_fFrPart;       
    //Indice/Epais. lame
	 	ar >> m_fAng;
  	ar >> m_fVit;
  	ar >> m_fIndice;
  	ar >> m_fEpais;
  	ar >> (WORD&)m_iNbFr1;    
  	ar >> m_fAlpha0;
  	ar >> m_fU0;       
  	ar >> m_fAlpha1;
  	ar >> m_fAlpha2;
  	ar >> m_fUmax;       
  	ar >> m_fUmin;       
 		ar >> (WORD&)m_iFrCentre;  
  	ar >> m_fFrPart1;       
		//Pression
		ar >> m_faP;
		ar >> m_fbP;

    //Mesures
		ar >> (WORD&)m_iNbA;	//Indice de l'air
		ar >> (WORD&)m_iNbL;  //Indice lame
    
    for (i=0;i<m_iNbAcq;i++)
		{
			for (j=0;j<4;j++)
			{
				ar >> m_fT[i][j];
			}
		}                    
		//Srialisation infos  
		m_sTab.RemoveAll();
		ar >> (WORD&)j;
		for (i=0;i<j;i++)
		{  
			ar >>s; 
			m_sTab.Add(s);
		} 
		ar >> m_fXinfo;
		ar >> m_fYinfo;
	}   
}
//________________________________________
// CBkDoc diagnostics

#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}

#endif //_DEBUG
//________________________________________
// CBkDoc commands
void CBkDoc::CalculFranges(int TypeGr)
{
	//Calcul des paramtres en fonction du nb. de franges graphe
	//d'aprs MAC_ZEHN.CPP Borland C
	float
		u,u0,u_mini,u_maxi,u_moy,u_maxi1,u_mini1,amplitude,u_der,
		f,r,r1,angle2,angle1,angle0;
	int 
		nb,nb_max,i,j,k;	
	char 
		COL,ok;	
		
	switch (TypeGr)
	{
		case 0://Air
			COL=0;//Colonne absisse dans le tableau m_fT
			nb=m_iNbA;
		break;
		case 1://Lame
			COL=2;//Colonne absisse dans le tableau m_fT
			nb=m_iNbL;
		break;
	}

  //Initialisation tableau position des franges
  for (i=0;i<100;i++)
  {
 		m_iTfr[1][i]=9999;
  }          

	u_mini=1e10;u_maxi=-1e10;
	//Recherche valeur moyenne
	for (i=0;i<nb;i++)
	{
	  u=m_fT[i][COL+1];
	  if (fabs(u)<11)
	  {
			if (u<u_mini) u_mini=u;
			if (u>u_maxi) u_maxi=u;           
		}
	} 
	u_moy=(u_maxi+u_mini)/2;
	amplitude=(float)(fabs(u_maxi-u_mini));              

  /*
	char afx[80];
	sprintf(afx,"%8.3f, %8.3f\n",u_moy,amplitude);
	AfxMessageBox(afx);
	*/

	nb_max=0;
	ok=0;
	u_maxi1=-1e10;u_mini1=1e10;
	u_der=m_fT[0][COL+1];
	for (i=1;i<nb;i++)
	{
	  u=m_fT[i][COL+1];
		if (fabs(u)<11)
		{
			//Valeur valide
			if (u>u_maxi1 && ok>=0)
			{                    
				//OK pour recherche de maxi
				u_maxi1=u;
			}
			if (u<u_mini1 && ok<=0)
			{ 
				//OK pour recherche de mini 
				u_mini1=u;                 
			}          
			if (u<u_maxi1 && ok>=0)
			{                    
				//On a trouv un maxi
				//Ce maxi est-il significatif (parasites,...)?
				//if(u>0.7*u_maxi)
				if (u>u_moy && fabs(u-u_der)>amplitude/4 && u>m_fT[i+2][COL+1])
				{
					//Oui
					if (nb_max==0) j=i;//Mmorisation angle de dpart
					k=i;//Angle courant
					ok=-1;			//On cherche maintenant un mini
					u_der=u;		//On mesure la tension du dernier maxi
					u_mini1=1e10;//On initialise le prochain mini
					u_maxi1=-1e10;
					//On mmorise l'index de la frange
					if (nb_max<100) m_iTfr[COL][nb_max]=i-1;
					nb_max++;				//On a trouv un maxi de plus
				}
			}                               
			else
			if (u>u_mini1 && ok<=0)
			{                    
				//On a trouv un mini
				//Ce mini est-il significatif (parasites,...)?
				//if (/*fabs(u-u_der)>amplitude/5*/u<u_moy )
				if (u<u_moy)
				{
					//Oui
					ok=1;				//On cherche maintenant un maxi
					u_der=u;		//On mesure la tension du dernier mini
					u_maxi1=-1e10;	//On initialise le prochain mini
					u_mini1=1e10;
				}
			}	
		}
	}
	if (nb_max>100) nb_max=100;

	if (TypeGr==1)
	{
	//Calculs angles pour paisseur lame
		angle2=m_fT[j-1][COL];
		angle1=m_fT[k-1][COL];
		angle0=(angle1+angle2)/2;
		//Recherche position j frange centrale
		r=1e10;//Ecart
		j=0;
		for (i=0;i<nb;i++)
		{
	    if (fabs(m_fT[i][COL]-angle0)<r)
			{
				r=(float)(fabs(m_fT[i][COL]-angle0));
				j=i;
			}
		}
		//Affectation
		m_fAlpha1=angle1;
		m_fAlpha2=angle2;
		m_fAlpha0=angle0;
 	
		//Recherche type [S] ou [C], frange sombre ou claire au centre
		if (j!=0 && j+6<nb && j-6>=0)
		{ 
			u0=m_fT[j][COL+1];
			//Recherche si les points -6 et +6 sont plus hauts ou bas
			r=m_fT[j-6][COL+1];
			r1=m_fT[j+6][COL+1];
			if (r<u0 && r1<u0)
				m_iFrCentre=0;	//type='C';
			else
			if (r>u0 && r1>u0)
				m_iFrCentre=1;	//type='S';
		}
 	 //Prise en compte des franges partielles
		f=0;
		if (m_iFrCentre==1 && u0>(u_maxi-u_mini)/2) 	//S
		{
			//3.2.1
			f=(u_maxi-u0)/(u_maxi-u_mini);
		}
		if (m_iFrCentre==1 && u0<(u_maxi-u_mini)/2)  	//S
		{
			//3.2.2
			f=-(u0-u_mini)/(u_maxi-u_mini);
		}
		if (m_iFrCentre==0 && u0>(u_maxi-u_mini)/2)		//C
		{
			//3.2.3
			f=-(u_maxi-u0)/(u_maxi-u_mini);
		}
		if (m_iFrCentre==0 && u0<(u_maxi-u_mini)/2)  	//C
		{
			//3.2.4
			f=(u0-u_mini)/(u_maxi-u_mini);
		}
	}

	//Affectation
	switch (TypeGr)
	{
		case 0://Air
			m_iNbFr=nb_max;
			//Sans intrt ...
			//m_fFrPart=f;	
		break;
		case 1://Lame
			m_iNbFr1=nb_max;
			m_fFrPart1=f;	
		break;
	}
}
//__ Classe CDMC _________________________
CDMC::CDMC()
{
	for (int i=0;i<3;i++)
	{
		m_fa[i]=1e10;
	 	m_fb[i]=1e10;
	 	m_iNoCourbe[i][0]=-1;
	 	m_iNoCourbe[i][1]=-1;
	 	m_iNoPt[i][0]=-1;
	 	m_iNoPt[i][1]=-1;
	 	m_iNoBtn[i]=0;
	 	m_OKPt[i][0]=FALSE;		//Point 1 non mmoris
	 	m_OKPt[i][1]=FALSE;		//Point 2 non mmoris
	 	m_OKCalcul[i]=FALSE;	//Coefficients DMC non calculs
	 	m_OKTrace[i]=TRUE;		//Option trac de la DMC coche par dfaut
	}
	m_iNo=0;							//Rfrence de la dmc
}
