// bkdoc.h : interface of the CBkDoc class
//________________________________________
class CBkDoc : public CDocument
{
protected: // create from serialization only
	CBkDoc();
	DECLARE_DYNCREATE(CBkDoc)

// Attributes
public:
	class CDMC *m_pDMC;
  //Nb. de mesures
	short 
		m_iTypeGr,		//Type de graphe (0: air, 1:lame)
		m_iNbAcq,			//Nb. total d'acquisitions  
		m_iNbA,				//Nb. effectif d'aquisitions (indice de l'air)
		m_iNbL;				//Nb. effectif d'acquisitions (indice lame)
	float (*m_fT)[4];	
	//Type de carte A/N
	short m_iTypeCarte;

	//Variables pour mesure indice de l'air
	short
		m_iTempo;			//Tempo entre les acquisitions
	float	
		m_fP1,					//Pression initiale
		m_fP2,					//Pression finale
		m_fLambda,			//Long. d'onde
		m_fLg,					//Long. de la cavit
		m_fFrPart;
	int		
		m_iNbFr,				//Nb. de franges
		m_iNbPts;				//Nb. d'acquisitions  faire pour indice de l'air
  unsigned int 
    m_iTfr[2][100]; //Tableau contenant la position des maxis
  //Variables pour mesure de l'paisseur de la lame
  float
  	m_fAng,					//Demi-angle de scanning
  	m_fVit,					//Vitesse de scanning
  	m_fIndice,			//Indice calcul en fonction paisseur
  	m_fEpais,				//Epaisseur calcule en fonction indice
  	m_fAlpha0,			//Dcalage d'origine
  	m_fU0,					//Tension  l'origine       
  	m_fAlpha1,
  	m_fUmax,
  	m_fAlpha2,
  	m_fUmin,
  	m_fFrPart1;			//Frange partielle
  int	
  	m_iNbFr1,
  	m_iFrCentre;		//Frange partielle au centre (C ou S)

   CString
   	m_sNomFicTxt,
   	m_sNomFic;	
    
	//Variables pour le trac graphique 
 	float 
 		m_fLarg,m_fHaut,
 		m_fXmi,m_fXma,m_fYmi,m_fYma,
 		m_fEchx,m_fEchy,
 		m_fXori,m_fYori,
 		m_fFactx,m_fFacty; 
 	int	
 		m_iAxe_abs,m_iAxe_ord;  
 	CStringArray				//Tableau de chane CInfoDlg
 		m_sTab;
 	float
 		m_fXinfo,m_fYinfo;//Position d'criture infos			
 	BOOL 
 		m_OKinfo,					//Ecriture des infos 
 		m_bOKSou,					//Affichage bote de dialogue coord. souris
 		m_bOKDmc;					//Affichage bote de dialogue DMC          
 	//Carte Eurosmart
 	int
		//[0]:Franges, [1]:Pression 
		m_iNoVoie[2],			//Voie d'acquisition
		m_iTypePol[2],		//Type d'acquisition
		m_iMoy[2];				//Moyennage 
	//Mesure pression
	float
		m_faP,m_fbP;
	//Bote de dialogue dtails			  
	int
		m_iNoBtn;					//N de bouton actif dans bote de dialogue dtails	
// Operations
public:
	void CalculFranges(int TypeGr);

// Implementation
public:
	virtual ~CBkDoc();
	virtual void Serialize(CArchive& ar);	// overridden for document i/o
#ifdef _DEBUG
	virtual	void AssertValid() const;
	virtual	void Dump(CDumpContext& dc) const;
#endif
protected:
	virtual	BOOL	OnNewDocument();

// Generated message map functions
protected:
	//{{AFX_MSG(CBkDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
class CDMC:public CObject
{
	public:
		CDMC();
  
  //Attributes     
	float 
		m_fa[3],m_fb[3],		// [3]: N de la dmc   
		m_fP1[3][2],				//Coord. pts P1 et P2
		m_fP2[3][2];
	int
		m_iNo,							//N de la dmc en cours [0,2]
		m_iNoCourbe[3][2],
		m_iNoPt[3][2],
		m_iNoBtn[3]; 				//P1 ou P2
	BOOL
		m_OKPt[3][2],   		//Pt 1 et pt 2 digitalis, TRUE/FALSE
		m_OKCalcul[3],			//DMC calcule
		m_OKTrace[3];				//Option trac DMC de la bote de dialogue	
  //Operations      		
};		
