// dmcdlg.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "dmcdlg.h"
#include "bkdoc.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CDmcDlg dialog
CDmcDlg::CDmcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDmcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDmcDlg)
	m_sInfo = "";
	m_OK = FALSE;
	m_sa = "";
	m_sb = "";
	m_radioNo = -1;
	//}}AFX_DATA_INIT

	//A ajouter:
	Create(IDD_DMC,pParent);
}
void CDmcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDmcDlg)
	DDX_Control(pDX, IDCALCUL, m_btnCalcul);
	DDX_Text(pDX, IDC_INFO, m_sInfo);
	DDX_Check(pDX, IDC_TRACE, m_OK);
	DDX_Text(pDX, IDC_A, m_sa);
	DDX_Text(pDX, IDC_B, m_sb);
	DDX_Radio(pDX, IDC_DMC0, m_radioNo);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CDmcDlg, CDialog)
	//{{AFX_MSG_MAP(CDmcDlg)
	ON_BN_CLICKED(IDPT1, OnPt1)
	ON_BN_CLICKED(IDPT2, OnPt2)
	ON_BN_CLICKED(IDCALCUL, OnCalcul)
	ON_BN_CLICKED(IDC_DMC0, OnClickedDmc0)
	ON_BN_CLICKED(IDC_DMC1, OnClickedDmc1)
	ON_BN_CLICKED(IDC_DMC2, OnClickedDmc2)
	ON_BN_CLICKED(IDC_TRACE, OnClickedTrace)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CDmcDlg message handlers
void CDmcDlg::PostNcDestroy()
{
	delete this;
}
//__________________________________________________
BOOL CDmcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	//Valeurs courantes
	//A faire avec Affecte !
	//m_fa=m_pDoc->m_pDMC->m_fa;      
	//m_fb=m_pDoc->m_pDMC->m_fb;
	//m_OK=m_pDoc->m_pDMC->m_OKTrace;      
	m_btnCalcul.EnableWindow(FALSE);
  m_sInfo="Cliquez sur point 1 et 2 pour\r\nslectionner deux points\r\nappartenant  la mme courbe.";
	UpdateData(FALSE); 
	return TRUE;
}
//__________________________________________________
void CDmcDlg::Affecte(int no,float a,float b,BOOL OK)
{
  char s[20];
	m_fa=a;
	m_fb=b; 
	
	if (a==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%1.4e",a);
	m_sa=s;	
	if (b==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%+1.4e",b);
	m_sb=s;	
		
	m_OK=OK;  
	m_radioNo=no;
	UpdateData(FALSE);
}
//__________________________________________________
void CDmcDlg::AffecteS(CString s)
{
	m_sInfo=s;
	UpdateData(FALSE);
}
//__________________________________________________
void CDmcDlg::OnPt1()
{
	//Premier point de la DMC
  m_sInfo="Placer le curseur de la souris\r\nsur le 1er point de la DMC.\r\nCliquez sur le bouton gauche.";
	UpdateData(FALSE); 
	m_pDoc->m_pDMC->m_iNoBtn[m_radioNo]=1;//Clic souris devient actif -> bkview.cpp
	m_pDoc->m_pDMC->m_iNo=m_radioNo;
}
//__________________________________________________
void CDmcDlg::OnPt2()
{
	//Deuxime point de la DMC
  m_sInfo="Placer le curseur de la souris\r\nsur le 2me point de la DMC.\r\nCliquez sur le bouton gauche.";
	UpdateData(FALSE); 
	m_pDoc->m_pDMC->m_iNoBtn[m_radioNo]=2;//Clic souris devient actif
	m_pDoc->m_pDMC->m_iNo=m_radioNo;
}
//__________________________________________________
void CDmcDlg::OnCalcul()
{
	//Les deux points ont t slectionns, on peut calculer les coef. de la dmc
	
	float 
	  a=0,b=0,
		x,y,
		sx=0,sy=0,sx2=0,sxy=0,det;
  int
  	indice1,indice2,
  	i,i1,j,j1,k,nb;
  char s[20];	
  	
  j=m_pDoc->m_pDMC->m_iNoCourbe[m_radioNo][0];
  j1=m_pDoc->m_pDMC->m_iNoCourbe[m_radioNo][1];
  if (m_pDoc->m_pDMC->m_iNoPt[m_radioNo][0]<m_pDoc->m_pDMC->m_iNoPt[m_radioNo][1])
  {
  	i=m_pDoc->m_pDMC->m_iNoPt[m_radioNo][0];
  	i1=m_pDoc->m_pDMC->m_iNoPt[m_radioNo][1];
  }
  else
  {
  	i1=m_pDoc->m_pDMC->m_iNoPt[m_radioNo][0];
  	i=m_pDoc->m_pDMC->m_iNoPt[m_radioNo][1];
  }          
  
  //sprintf(s,"Courbe %d, courbe %d\r\nIndice %d, indice %d\r\n",j,j1,i,i1);
  //m_sInfo=s;
	//UpdateData(FALSE); 
  
  if (i!=i1 && j==j1)
  {
		//Pts d'indice i diffrents et appartenant  la mme courbe
		sx=0;sy=0;sx2=0;sxy=0;nb=0;
		for (k=i;k<i1;k++)
		{

			switch (m_pDoc->m_iAxe_abs)
			{
				case 0:indice1=0;break;
				case 1:indice1=1;break;
				case 2:indice1=2;break;
				case 3:indice1=3;break;
				case 4:indice1=4;break;
			}
			switch (j)
			{
				case 1:indice2=0;break;
				case 2:indice2=1;break;
				case 4:indice2=2;break;
				case 8:indice2=3;break;
				case 16:indice2=4;break;
			} 
			x=m_pDoc->m_fT[k][indice1];
			y=m_pDoc->m_fT[k][indice2];
			
			
			if (x!=1e10 && y!=1e10)
			{
			  //sprintf(s,"T[%d][%d]  \tX:%9.3e\r\nT[%d][%d]  \tY:%9.3e",k,indice1,x,k,indice2,y);
  			//m_sInfo=s;
				//UpdateData(FALSE); 
				sx2=sx2+x*x;
				sx=sx+x;
				sxy=sxy+x*y;
				sy=sy+y;
				nb++;
			}
		}//for
		if (nb>2)
		{
			det=sx2*nb-sx*sx;
			if (fabs(det)<1e-10)
			{
				a=1e10;b=1e10;
  			m_sInfo="Le calcul de la DMC a chou !";
				m_pDoc->m_pDMC->m_OKCalcul[m_radioNo]=FALSE;
			}
			else
			{
  			m_sInfo="Calcul de la DMC termin !\r\nCochez ventuellement Tracer...,\r\npuis Fermer.";
				a=-(-sxy*nb+sy*sx)/det;
				b=(sx2*sy-sx*sxy)/det;  
				m_pDoc->m_pDMC->m_OKCalcul[m_radioNo]=TRUE;
	  	}
	  }
	}                                 
	m_fa=a;m_fb=b;
	if (a==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%1.4e",a);
	m_sa=s;	         
	if (b==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%+1.4e",b);
	m_sb=s;	
	UpdateData(FALSE); 
	//Mise  jour
	m_pDoc->m_pDMC->m_fa[m_radioNo]=m_fa;
	m_pDoc->m_pDMC->m_fb[m_radioNo]=m_fb;
}
//__________________________________________________
void CDmcDlg::OnClickedDmc0()
{
	char s[20];
	m_radioNo=0;
	m_fa=m_pDoc->m_pDMC->m_fa[0];
	m_fb=m_pDoc->m_pDMC->m_fb[0];
	m_OK=m_pDoc->m_pDMC->m_OKTrace[0];
	if (m_fa==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%1.4e",m_fa);
	m_sa=s;	         
	if (m_fb==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%+1.4e",m_fb);
	m_sb=s;	
	UpdateData(FALSE);
}
//__________________________________________________
void CDmcDlg::OnClickedDmc1()
{
	char s[20];
	m_radioNo=1;
	m_fa=m_pDoc->m_pDMC->m_fa[1];
	m_fb=m_pDoc->m_pDMC->m_fb[1];
	m_OK=m_pDoc->m_pDMC->m_OKTrace[1];
	if (m_fa==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%1.4e",m_fa);
	m_sa=s;	         
	if (m_fb==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%+1.4e",m_fb);
	m_sb=s;	
	UpdateData(FALSE);
}
//__________________________________________________
void CDmcDlg::OnClickedDmc2()
{
	char s[20];
	m_radioNo=2;
	m_fa=m_pDoc->m_pDMC->m_fa[2];
	m_fb=m_pDoc->m_pDMC->m_fb[2];
	m_OK=m_pDoc->m_pDMC->m_OKTrace[2];
	if (m_fa==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%1.4e",m_fa);
	m_sa=s;	         
	if (m_fb==1e10)
		sprintf(s,"?");
	else
		sprintf(s,"%+1.4e",m_fb);
	m_sb=s;	
	UpdateData(FALSE);
}
//__________________________________________________
void CDmcDlg::OnClickedTrace()
{
	UpdateData(TRUE);
	m_pDoc->m_pDMC->m_OKTrace[m_radioNo]=m_OK;
}
//__________________________________________________
void CDmcDlg::OnCancel()
{
	// TODO: Add extra cleanup here
	CWnd* pParent=GetParent();
	CMenu* pMenu=pParent->GetMenu();
	//On peut maintenant re-ouvrir une bote de dialogue
	m_pDoc->m_bOKDmc=FALSE;                         
	//On dcoche la rubrique du menu
	pMenu->CheckMenuItem(ID_DMC,MF_UNCHECKED);
  //UpdateData(TRUE);
	//Affectation des variables
	//m_pDoc->m_pDMC->m_iNo=m_radioNo;
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnCancel();
}
