// EpaisLDlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "EpaisLDlg.h"
#include "Bkdoc.h"
#include "Bkview.h"
//#include "EurosmartDX.h"
//#include "CandibusDX.h"
#include "Eurosmart.h"
#include "Candibus.h"

#include "C832DX.h"
#include <math.h>
#include "detaidlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CEpaisLDlg dialog
CEpaisLDlg::CEpaisLDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEpaisLDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEpaisLDlg)
	m_fAng = 0.0f;
	m_fEpais = 0.0f;
	m_fIndice = 0.0f;
	m_fLambda = 0.0f;
	m_fFrPart = 0.0f;
	m_iNbFr = 0;
	m_s = _T("");
	m_fVit = 0.0f;
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_EPAIS_LAME,pParent);
}
void CEpaisLDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEpaisLDlg)
	DDX_Control(pDX, ID_DETAIL2, m_btnDetail);
	DDX_Control(pDX, ID_CALC_INDICE, m_btnIndice);
	DDX_Control(pDX, ID_CALC_EPAIS, m_btnEpais);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, ID_ACQ2, m_btnAcq);
	DDX_Control(pDX, ID_STOP, m_btnStop);
	DDX_Control(pDX, ID_FR, m_btnFr);
	DDX_Text(pDX, IDC_ANG, m_fAng);
	DDX_Text(pDX, IDC_EPAIS, m_fEpais);
	DDX_Text(pDX, IDC_INDICE, m_fIndice);
	DDX_Text(pDX, IDC_LAMBDA1, m_fLambda);
	DDX_Text(pDX, IDC_NB_FR_PART1, m_fFrPart);
	DDX_Text(pDX, IDC_NB_FRANGES, m_iNbFr);
	DDX_Text(pDX, IDC_STATIC_INFOA, m_s);
	DDX_Text(pDX, IDC_VIT, m_fVit);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CEpaisLDlg, CDialog)
	//{{AFX_MSG_MAP(CEpaisLDlg)
	ON_BN_CLICKED(ID_CALC_EPAIS, OnCalcEpais)
	ON_EN_KILLFOCUS(IDC_LAMBDA1, OnKillfocusLambda1)
	ON_EN_KILLFOCUS(IDC_EPAIS, OnKillfocusEpais)
	ON_EN_KILLFOCUS(IDC_ANG, OnKillfocusAng)
	ON_EN_KILLFOCUS(IDC_NB_FRANGES, OnKillfocusNbFranges)
	ON_EN_KILLFOCUS(IDC_INDICE, OnKillfocusIndice)
	ON_EN_KILLFOCUS(IDC_VIT, OnKillfocusVit)
	ON_EN_KILLFOCUS(IDC_NB_FR_PART1, OnKillfocusNbFrPart1)
	ON_BN_CLICKED(ID_ACQ2, OnAcq2)
	ON_BN_CLICKED(ID_STOP, OnStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(ID_FR, OnFr)
	ON_BN_CLICKED(ID_CALC_INDICE, OnCalcIndice)
	ON_BN_CLICKED(ID_DETAIL2, OnDetail2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CEpaisLDlg message handlers
void CEpaisLDlg::Affecte()
{
	m_pDetailDlg->Affecte(1);//0:Air, 1::Lame. Pour faire la diffrence entre NbFr et NbFr1, ... 
}
//________________________________________
BOOL CEpaisLDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();  
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame-> GetActiveDocument();
	
	//Valeurs par dfaut
	m_fAng=m_pDoc->m_fAng;  
	m_fVit=m_pDoc->m_fVit;  
	m_fIndice=m_pDoc->m_fIndice;  
	m_fEpais=m_pDoc->m_fEpais;  
	m_fLambda=m_pDoc->m_fLambda;  
	m_iNbFr=m_pDoc->m_iNbFr1;  
	//m_fFrPart=m_pDoc->m_fFrPart1;  
	m_fFrPart=0;

	m_pC832=new CC832DX(29600);
	m_pEuro=new CEurosmart();
	m_pCand=new CCandibus();
	//On invalide  les boutons
	//A enlever pour test
	if (!m_pC832->OK(1))	
		m_btnAcq.EnableWindow(FALSE);
	if (m_pDoc->m_iTypeCarte==-1)
	{
		m_s.Format("Carte A/N non dtecte !");
		m_btnAcq.EnableWindow(FALSE);
	}
	else
	{
		m_s.Format("Cliquez sur Calcul indice, Calcul pais. ou faire une Acquisition...");
	}

	if (m_pDoc->m_iNbL==0)
	{
		m_btnFr.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);                    
	}	
	UpdateData(FALSE);	
	m_pDetailDlg=NULL;
	return TRUE;
}
//__________________________________________________
void CEpaisLDlg::OnCalcEpais() 
{
	//Calcul de l'paisseur en fonction de l'indice
	const float M_PI=(float)(4*atan(1));
	float num,denom,angle0,angle1,angle2;
	angle0=m_pDoc->m_fAlpha0*M_PI/180;
	angle1=m_pDoc->m_fAlpha1*M_PI/180;
	angle2=m_pDoc->m_fAlpha2*M_PI/180;
 
	if (fabs(m_fFrPart)<0.001) AfxMessageBox("Attention !\nA priori le nb. de franges partielles n'est pas nul...");

	//Numrateur
	num=(float)(m_fLambda*1e-6*(m_iNbFr-1+m_fFrPart));

	//Dnominateur
	denom=(float)(cos(asin(sin(angle1-angle0)/m_fIndice)));
	denom=(float)(denom+cos(asin(sin(angle0-angle2)/m_fIndice)));
	denom=denom*m_fIndice;
	denom=(float)(denom-cos(angle1-angle0)-cos(angle0-angle2)-2*m_fIndice+2);
	m_fEpais=num/denom;
	UpdateData(FALSE);
	m_pDoc->m_fEpais=m_fEpais;
}
//_________________________________________________
void CEpaisLDlg::OnKillfocusLambda1() 
{
	UpdateData(TRUE);
	if (m_fLambda<100) m_fLambda=632.8;
	if (m_fLambda>1000) m_fLambda=632.8;
	m_pDoc->m_fLambda=m_fLambda;
	UpdateData(FALSE); 
}
//_________________________________________________
void CEpaisLDlg::OnKillfocusEpais() 
{
	UpdateData(TRUE);
	if (m_fEpais<0.05) m_fEpais=0.05;
	if (m_fEpais>5) m_fEpais=5;
	m_pDoc->m_fEpais=m_fEpais;
	UpdateData(FALSE); 
}
//_________________________________________________
void CEpaisLDlg::OnKillfocusAng() 
{
	UpdateData(TRUE);
	if (m_fAng<1) m_fAng=1;
	if (m_fAng>60) m_fAng=60;
	m_pDoc->m_fAng=m_fAng;
	UpdateData(FALSE); 
}
//_________________________________________________
void CEpaisLDlg::OnKillfocusNbFranges() 
{
	UpdateData(TRUE);      
	if (m_iNbFr<3) m_iNbFr=3;
	if (m_iNbFr>1000) m_iNbFr=1000;
	m_pDoc->m_iNbFr1=m_iNbFr;
	UpdateData(FALSE); 
}
//_________________________________________________
void CEpaisLDlg::OnKillfocusIndice() 
{
	UpdateData(TRUE);
	if (m_fIndice<1.4) m_fIndice=1.4;
	if (m_fIndice>2.5) m_fIndice=2.5;
	m_pDoc->m_fIndice=m_fIndice;
	UpdateData(FALSE); 
}
//_________________________________________________
void CEpaisLDlg::OnKillfocusVit() 
{
	UpdateData(TRUE);
	if (m_fVit<5) m_fVit=5;
	if (m_fVit>360) m_fVit=360;
	m_pDoc->m_fVit=m_fVit;
	UpdateData(FALSE); 
}
//_________________________________________________
void CEpaisLDlg::OnKillfocusNbFrPart1() 
{
	//Modification du nombre de franges partielles
	UpdateData(TRUE);
	if (m_fFrPart<-1) m_fFrPart=-1;
	if (m_fFrPart>1) m_fFrPart=1;
	m_pDoc->m_fFrPart1=m_fFrPart;
	UpdateData(FALSE); 
}
//_________________________________________________
void CEpaisLDlg::OnAcq2() 
{
	//Acquisition du spectre par rotation de la platine motorise
  //Initialisation tableau position des franges
  int i,j;
  for (i=0;i<100;i++)
  {
 		m_pDoc->m_iTfr[1][i]=9999;
  }          
  //Initialisation du tableau
  for (i=2;i<=3;i++)
  {
  	for (j=0;j<m_pDoc->m_iNbAcq;j++)
  	{
  		m_pDoc->m_fT[j][i]=1e10;
  	}
  }          
	//On valide/invalide les boutons
	m_btnStop.EnableWindow(TRUE);
	m_btnAcq.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnEpais.EnableWindow(FALSE);
	m_btnIndice.EnableWindow(FALSE);

	m_pDoc->m_iNbL=0;                    
	m_pDoc->m_iTypeGr=1;
	m_pDoc->m_iAxe_abs=2;
	m_pDoc->m_iAxe_ord=8;
	
	//Initialisation paramtres
	//m_pDoc->m_pC832->RT(1);//Reset axes
	if (m_pC832->OK(1))
	{
		//Position origine en vitesse rapide
		m_pC832->SV(1,360);
		Sleep(10);
		m_pC832->MA(1,-m_fAng);
		m_pC832->WS(1);             

		CString z;
		z.Format("Angle dpart (): %4.1f",-m_fAng);
		AfxMessageBox(z);
		
		//Destination en vitesse de scan
		m_pC832->SV(1,m_pDoc->m_fVit);
		Sleep(10);
		m_pC832->MA(1,m_fAng);

		//Pas d'attente de fin de mvt pour timer!
		SetTimer(0,10,NULL);
		// Demande de sauvegarde  la sortie
		m_pDoc->SetModifiedFlag();
	}	
}
//_________________________________________________
void CEpaisLDlg::OnCancel() 
{
	delete m_pC832;
	delete m_pEuro;
	delete m_pCand;

	KillTimer(0);

	CFrameWnd *pFrame=(CFrameWnd *) (AfxGetApp()->m_pMainWnd);
	CBkView *pView=(CBkView*)pFrame-> GetActiveView();
	pView->m_pEpaisDlg=NULL;
	CDialog::OnCancel();
}
//_________________________________________________
void CEpaisLDlg::OnStop() 
{
	//On valide/invalide  les boutons
	m_btnStop.EnableWindow(FALSE);
	m_btnAcq.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);
	m_btnIndice.EnableWindow(TRUE);
	m_btnEpais.EnableWindow(TRUE);
	if (m_pDoc->m_iNbL>0)
	{
		m_btnFr.EnableWindow(TRUE);
		CalculMaxiMini();
	}

	//On dsire arrter l'acquisition d'un spectre
	KillTimer(0);                           
	//On arrte la platine
	m_pC832->ST(1);
	m_s.Format("Acquisition arrte par l'utilisateur...\n(%d valeurs)",m_pDoc->m_iNbL);
	UpdateData(FALSE);
}
//_________________________________________________
void CEpaisLDlg::OnTimer(UINT nIDEvent) 
{
	float u,ang;                        
	//Carte PI
	ang=m_pC832->TP(1);
	if (m_pDoc->m_iNbL<m_pDoc->m_iNbAcq && ang<m_fAng)
	{
		switch(m_pDoc->m_iTypeCarte)
		{
			case 0://Eurosmart
				u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[0],m_pDoc->m_iTypePol[0],m_pDoc->m_iMoy[0]);
			break;
			case 1://Candibus
				u=m_pCand->LitTension(m_pDoc->m_iNoVoie[0],m_pDoc->m_iMoy[0]);
			break;
			default://Aucune
				u=1e10;
			break;
		}
		//Ca ralentit l'acquisition...
		if (u!=1e10)
			m_s.Format("%d/%d\nAng():%6.2f - U(V): %8.3f",m_pDoc->m_iNbL,m_pDoc->m_iNbAcq,ang,u);
		else
			m_s.Format("%d/%d\nAng():%6.2f - U(V): ?",m_pDoc->m_iNbA,m_pDoc->m_iNbAcq,ang);
		UpdateData(FALSE);
			//Affectation
		m_pDoc->m_fT[m_pDoc->m_iNbL][2]=ang;	
		m_pDoc->m_fT[m_pDoc->m_iNbL][3]=u;	
		m_pDoc->m_iNbL++;
	} 
	else
	{
		//Fin de l'acquisition
		KillTimer(0);
		//On arrte la platine
		m_pC832->ST(1);
		//On valide/invalide  les boutons
		if (m_pDoc->m_iNbL>0) m_btnFr.EnableWindow(TRUE);
		m_btnStop.EnableWindow(FALSE);
		m_btnAcq.EnableWindow(TRUE);
		m_btnCancel.EnableWindow(TRUE);
		m_btnIndice.EnableWindow(TRUE);
		m_btnEpais.EnableWindow(TRUE);
		m_s.Format("Fin d'acquisition.\n(%d/%d)",m_pDoc->m_iNbL,m_pDoc->m_iNbAcq);
		UpdateData(FALSE);
		m_pDoc->UpdateAllViews(NULL);
		if (m_pDoc->m_iNbL>3)	CalculMaxiMini();
	}
	CDialog::OnTimer(nIDEvent);
}
//_________________________________________________
void CEpaisLDlg::OnFr() 
{
	//Clic sur graphe pour dcoder l'acquisition
	m_pDoc->CalculFranges(1);
	m_iNbFr=m_pDoc->m_iNbFr1;
  m_fFrPart=m_pDoc->m_fFrPart1;	
	UpdateData(FALSE);	
	//Visualisation de la position des franges par des cercles -> non, car franges partielles
	m_pDoc->UpdateAllViews(NULL);
}
//_________________________________________________
void CEpaisLDlg::OnCalcIndice() 
{
	const float M_PI=(float)(4*atan(1));
	//Calcul de l'indice en fonction de l'paisseur
	float d,num,denom,angle0,angle1,angle2;
	num=(float)(m_fLambda*1e-6*(m_iNbFr-1+m_fFrPart));
	d=1;                     
	angle0=m_pDoc->m_fAlpha0*M_PI/180;
	angle1=m_pDoc->m_fAlpha1*M_PI/180;
	angle2=m_pDoc->m_fAlpha2*M_PI/180;

	if (fabs(m_fFrPart)<0.001) AfxMessageBox("Attention !\nA priori le nb. de franges partielles n'est pas nul...");


	//angle0=0;
	//angle1=m_fAng*M_PI/180;
	//angle2=-m_fAng*M_PI/180;
	
	do
	{
		denom=(float)(cos(asin(sin(angle1-angle0)/d)));
		denom=(float)(denom+cos(asin(sin(angle0-angle2)/d)));
		denom=denom*d;
		denom=(float)(denom-cos(angle1-angle0)-cos(angle0-angle2)-2*d+2);
		d=(float)(d+0.001);
	}
	while (d<1.8 && fabs(num-denom*m_fEpais>1e-5));//Ecart permis
	//Affectation indice
	m_fIndice=d;
	UpdateData(FALSE);
	m_pDoc->m_fIndice=m_fIndice;
}
//_________________________________________________
void CEpaisLDlg::OnDetail2() 
{
	
	//Clic sur dtails pour spcifier les paramtres  la souris avec une
	//bote de dialogue NON MODALE !
	//Ouverture bote de dialogue non modale si elle n'est pas dj ouverte
	m_pDetailDlg=new CDetailDlg(this);
	//Transmission pDoc vers bote de dialogue	
	m_pDetailDlg->Affecte(1);//0:Air, 1::Lame. Pour faire la diffrence entre NbFr et NbFr1, ... 

	m_btnDetail.EnableWindow(FALSE);
	
}
//_________________________________________________
void CEpaisLDlg::CalculMaxiMini() 
{
	float u;
	short i;
	if (m_pDoc->m_iNbL>2)
	{
		m_pDoc->m_fUmax=1;
		m_pDoc->m_fUmin=0;
	}
	else
	{
		m_pDoc->m_fUmax=-1e10;
		m_pDoc->m_fUmin=1e10;
		for (i=0;i<m_pDoc->m_iNbL;i++)
		{
			u=m_pDoc->m_fT[m_pDoc->m_iNbL][3];
			if (u>m_pDoc->m_fUmax) m_pDoc->m_fUmax=u;
			if (u<m_pDoc->m_fUmin) m_pDoc->m_fUmin=u;
		}
	}
}
