// epaisdlg.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "epaisdlg.h"
#include "bkdoc.h"
#include "detaidlg.h"
#include "eurosmart.h"
#include "c832.h"
#include <math.h>            

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEpaisDlg dialog

CEpaisDlg::CEpaisDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEpaisDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEpaisDlg)
	m_fAng = 0;
	m_fVit = 0;
	m_fIndice = 0;
	m_fEpais = 0;
	m_fAlpha0 = 0;
	m_iNbFr = 0;
	m_fFrPart = 0;
	m_fLambda = 0;
	//}}AFX_DATA_INIT

	//A ajouter:
	Create(IDD_EPAIS,pParent);
}

void CEpaisDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEpaisDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, ID_STOP, m_btnStop);
	DDX_Control(pDX, ID_FR, m_BtnFr);
	DDX_Control(pDX, ID_CALC_INDICE, m_btnIndice);
	DDX_Control(pDX, ID_CALC_EPAIS, m_btnEpais);
	DDX_Control(pDX, ID_ACQ2, m_btnAcq);
	DDX_Text(pDX, IDC_ANG, m_fAng);
	DDX_Text(pDX, IDC_VIT, m_fVit);
	DDX_Text(pDX, IDC_INDICE, m_fIndice);
	DDX_Text(pDX, IDC_EPAIS, m_fEpais);
	DDX_Text(pDX, IDC_NB_FRANGES, m_iNbFr);
	DDX_Text(pDX, IDC_NB_FR_PART1, m_fFrPart);
	DDX_Text(pDX, IDC_LAMBDA1, m_fLambda);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEpaisDlg, CDialog)
	//{{AFX_MSG_MAP(CEpaisDlg)
	ON_BN_CLICKED(ID_CALC_EPAIS, OnCalcEpais)
	ON_BN_CLICKED(ID_CALC_INDICE, OnCalcIndice)
	ON_EN_KILLFOCUS(IDC_LAMBDA1, OnKillfocusLambda1)
	ON_EN_KILLFOCUS(IDC_EPAIS, OnKillfocusEpais)
	ON_EN_KILLFOCUS(IDC_ANG, OnKillfocusAng)
	ON_EN_KILLFOCUS(IDC_NB_FRANGES, OnKillfocusNbFranges)
	ON_EN_KILLFOCUS(IDC_INDICE, OnKillfocusIndice)
	ON_EN_KILLFOCUS(IDC_VIT, OnKillfocusVit)
	ON_BN_CLICKED(ID_ACQ2, OnAcq)
	ON_BN_CLICKED(ID_STOP, OnStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(ID_FR, OnFranges)
	ON_EN_KILLFOCUS(IDC_NB_FR_PART1, OnKillfocusNbFrPart)
	ON_BN_CLICKED(ID_DETAIL2, OnDetail)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEpaisDlg message handlers
void CEpaisDlg::PostNcDestroy()
{
	delete this;
}
//__________________________________________________
BOOL CEpaisDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	//Pas d'initialisation ici pour une bote non modale !
	return TRUE;  // return TRUE  unless you set the focus to a control
}
//__________________________________________________
void CEpaisDlg::Affecte(class CBkDoc *pDoc)
{
	m_pDoc=pDoc;
	m_pC832=new CC832(29600);
	m_pEuro=new CEurosmart();

	char s[160];
	//Valeurs par dfaut
	m_fAng=m_pDoc->m_fAng;  
	m_fVit=m_pDoc->m_fVit;  
	m_fIndice=m_pDoc->m_fIndice;  
	m_fEpais=m_pDoc->m_fEpais;  
	m_fLambda=m_pDoc->m_fLambda;  
	m_iNbFr=m_pDoc->m_iNbFr1;  
	m_fFrPart=m_pDoc->m_fFrPart1;  
	//On invalide  les boutons
	//A enlever pour test
	if (/*!m_pDoc->m_bOKEuro ||*/ !m_pC832->OK(1))	
		m_btnAcq.EnableWindow(FALSE);
	if (m_pDoc->m_iNbL==0)
	{
		m_BtnFr.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);                    
	}	
	sprintf(s,"Cliquez sur Calcul indice, Calcul pais. ou faire une Acquisition...");
	SetDlgItemText(IDC_STATIC_INFO,s);
	UpdateData(FALSE);	
}
//__________________________________________________
void CEpaisDlg::OnCalcEpais()
{
	//Calcul de l'paisseur en fonction de l'indice
	const float M_PI=(float)(4*atan(1));
	float num,denom,angle0,angle1,angle2;
	angle0=m_pDoc->m_fAlpha0*M_PI/180;
	angle1=m_pDoc->m_fAlpha1*M_PI/180;
	angle2=m_pDoc->m_fAlpha2*M_PI/180;
  //Numrateur
	num=(float)(m_fLambda*1e-6*(m_iNbFr-1+m_fFrPart));
	//Dnominateur
	denom=(float)(cos(asin(sin(angle1-angle0)/m_fIndice)));
	denom=(float)(denom+cos(asin(sin(angle0-angle2)/m_fIndice)));
	denom=denom*m_fIndice;
	denom=(float)(denom-cos(angle1-angle0)-cos(angle0-angle2)-2*m_fIndice+2);
	m_fEpais=num/denom;
	UpdateData(FALSE);
	m_pDoc->m_fEpais=m_fEpais;
}
//__________________________________________________
void CEpaisDlg::OnKillfocusLambda1()
{
	UpdateData(TRUE);
	if (m_fLambda<100) m_fLambda=632.8;
	if (m_fLambda>1000) m_fLambda=632.8;
	m_pDoc->m_fLambda=m_fLambda;
	UpdateData(FALSE); 
}
//__________________________________________________
void CEpaisDlg::OnKillfocusEpais()
{
	UpdateData(TRUE);
	if (m_fEpais<0.05) m_fEpais=0.05;
	if (m_fEpais>5) m_fEpais=5;
	m_pDoc->m_fEpais=m_fEpais;
	UpdateData(FALSE); 
}
//__________________________________________________
void CEpaisDlg::OnKillfocusAng()
{
	UpdateData(TRUE);
	if (m_fAng<1) m_fAng=1;
	if (m_fAng>60) m_fAng=60;
	m_pDoc->m_fAng=m_fAng;
	UpdateData(FALSE); 
}
//__________________________________________________
void CEpaisDlg::OnKillfocusNbFranges()
{
	UpdateData(TRUE);      
	if (m_iNbFr<3) m_iNbFr=3;
	if (m_iNbFr>1000) m_iNbFr=1000;
	m_pDoc->m_iNbFr1=m_iNbFr;
	UpdateData(FALSE); 
}
//__________________________________________________
void CEpaisDlg::OnKillfocusIndice()
{
	UpdateData(TRUE);
	if (m_fIndice<1.4) m_fIndice=1.4;
	if (m_fIndice>2.5) m_fIndice=2.5;
	m_pDoc->m_fIndice=m_fIndice;
	UpdateData(FALSE); 
}
//__________________________________________________
void CEpaisDlg::OnKillfocusVit()
{
	UpdateData(TRUE);
	if (m_fVit<5) m_fVit=5;
	if (m_fVit>360) m_fVit=360;
	m_pDoc->m_fVit=m_fVit;
	UpdateData(FALSE); 
}
//__________________________________________________
void CEpaisDlg::OnKillfocusNbFrPart()
{
	//Modification du nombre de franges partielles
	UpdateData(TRUE);
	if (m_fFrPart<-1) m_fFrPart=-1;
	if (m_fFrPart>1) m_fFrPart=1;
	m_pDoc->m_fFrPart1=m_fFrPart;
	UpdateData(FALSE); 
}
//__________________________________________________
void CEpaisDlg::OnAcq()
{
	//Acquisition du spectre par rotation de la platine motorise
  //Initialisation tableau position des franges
  int i,j;
  for (i=0;i<100;i++)
  {
 		m_pDoc->m_iTfr[1][i]=9999;
  }          
  //Initialisation du tableau
  for (i=2;i<=3;i++)
  {
  	for (j=0;j<m_pDoc->m_iNbAcq;j++)
  	{
  		m_pDoc->m_fT[j][i]=1e10;
  	}
  }          
	//On valide/invalide les boutons
	m_btnStop.EnableWindow(TRUE);
	m_btnAcq.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnEpais.EnableWindow(FALSE);
	m_btnIndice.EnableWindow(FALSE);

	m_pDoc->m_iNbL=0;                    
	m_pDoc->m_iTypeGr=1;
	m_pDoc->m_iAxe_abs=2;
	m_pDoc->m_iAxe_ord=8;
	
	//Initialisation paramtres
	//m_pDoc->m_pC832->RT(1);//Reset axes
	if (m_pC832->OK(1))
	{
		//Position origine en vitesse rapide
		m_pC832->SV(1,360);
		Sleep(10);
		m_pC832->MA(1,-m_fAng);
		m_pC832->WS(1);             
		//Destination en vitesse de scan
		m_pC832->SV(1,m_pDoc->m_fVit);
		Sleep(10);
		m_pC832->MA(1,m_fAng);
		//Pas d'attente de fin de mvt pour timer!
		
	}	
	//On lance le timer (dclar dans RESOURCE.H)
	SetTimer(ID_LAME_TIMER,50,NULL);
	// Demande de sauvegarde  la sortie
	m_pDoc->SetModifiedFlag();
}
//__________________________________________________
void CEpaisDlg::OnCancel()
{
	delete m_pC832;
	delete m_pEuro;

	CDialog::OnCancel();
}
//__________________________________________________
void CEpaisDlg::OnStop()
{
	// TODO: Add your control notification handler code here
	//On valide/invalide  les boutons
	m_btnStop.EnableWindow(FALSE);
	m_btnAcq.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);
	m_btnIndice.EnableWindow(TRUE);
	m_btnEpais.EnableWindow(TRUE);
	if (m_pDoc->m_iNbL>0) m_BtnFr.EnableWindow(TRUE);

	char s[80];
	//On dsire arrter l'acquisition d'un spectre
	KillTimer(ID_LAME_TIMER);                           
	//On arrte la platine
	m_pC832->ST(1);

	sprintf(s,"Acquisition arrte par l'utilisateur...\n(%d valeurs)",m_pDoc->m_iNbL);
	SetDlgItemText(IDC_STATIC_INFO,s); 
	m_pDoc->UpdateAllViews(NULL);
}
//__________________________________________________
void CEpaisDlg::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	float u,ang;                        
	char s[80];
	
	//Carte PI
	ang=m_pC832->TP(1);
	if (m_pDoc->m_iNbL<m_pDoc->m_iNbAcq && ang<m_fAng)
	{
		//Eurosmart
		u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[0],m_pDoc->m_iTypePol[0],m_pDoc->m_iMoy[0]);
		//Ca ralentit l'acquisition...
		if (u!=1e10)
		{
			sprintf(s,"%d/%d\nAng():%6.2f - U(V): %8.3f",m_pDoc->m_iNbL,m_pDoc->m_iNbAcq,ang,u);
		}	
		else
			sprintf(s,"%d/%d\nAng():%6.2f - U(V): ####.###",m_pDoc->m_iNbA,m_pDoc->m_iNbAcq,ang);
		SetDlgItemText(IDC_STATIC_INFO,s);            

		//Affectation
		m_pDoc->m_fT[m_pDoc->m_iNbL][2]=ang;	
		m_pDoc->m_fT[m_pDoc->m_iNbL][3]=u;	
		m_pDoc->m_iNbL++;
	} 
	else
	{
		//Fin de l'acquisition
		KillTimer(ID_LAME_TIMER);
		//On arrte la platine
		m_pC832->ST(1);
		
		//On valide/invalide  les boutons
		if (m_pDoc->m_iNbL>0) m_BtnFr.EnableWindow(TRUE);
		m_btnStop.EnableWindow(FALSE);
		m_btnAcq.EnableWindow(TRUE);
		m_btnCancel.EnableWindow(TRUE);
		m_btnIndice.EnableWindow(TRUE);
		m_btnEpais.EnableWindow(TRUE);
		sprintf(s,"Fin d'acquisition.\n(%d/%d)",m_pDoc->m_iNbL,m_pDoc->m_iNbAcq);
		SetDlgItemText(IDC_STATIC_INFO,s);            
		m_pDoc->UpdateAllViews(NULL);
	}
	CDialog::OnTimer(nIDEvent);
}
//__________________________________________________
void CEpaisDlg::OnFranges()
{
	//Clic sur Graphe pour dcoder l'acquisition
	m_pDoc->CalculFranges(1);
	m_iNbFr=m_pDoc->m_iNbFr1;
  m_fFrPart=m_pDoc->m_fFrPart1;	
	UpdateData(FALSE);	
	//Visualisation de la position des franges par des cercles -> non, car franges partielles
	m_pDoc->UpdateAllViews(NULL);
}
//__________________________________________________
void CEpaisDlg::OnCalcIndice()
{
	const float M_PI=(float)(4*atan(1));
	//Calcul de l'indice en fonction de l'paisseur
	float d,num,denom,angle0,angle1,angle2;
	num=(float)(m_fLambda*1e-6*(m_iNbFr-1+m_fFrPart));
	d=1;                     
	angle0=m_pDoc->m_fAlpha0*M_PI/180;
	angle1=m_pDoc->m_fAlpha1*M_PI/180;
	angle2=m_pDoc->m_fAlpha2*M_PI/180;

	//angle0=0;
	//angle1=m_fAng*M_PI/180;
	//angle2=-m_fAng*M_PI/180;
	
	do
	{
		denom=(float)(cos(asin(sin(angle1-angle0)/d)));
		denom=(float)(denom+cos(asin(sin(angle0-angle2)/d)));
		denom=denom*d;
		denom=(float)(denom-cos(angle1-angle0)-cos(angle0-angle2)-2*d+2);
		d=(float)(d+0.001);
	}
	while (d<1.8 && fabs(num-denom*m_fEpais>1e-5));//Ecart permis
	//Affectation indice
	m_fIndice=d;
	UpdateData(FALSE);
	m_pDoc->m_fIndice=m_fIndice;
}
//__________________________________________________
void CEpaisDlg::OnDetail()
{
	//Clic sur dtails pour spcifier les paramtres  la souris avec une
	//bote de dialogue NON MODALE !
	CWnd* pParent=GetParent();
	CMenu* pMenu=pParent->GetMenu();
	//Ouverture bote de dialogue non modale si elle n'est pas dj ouverte
	m_pDetailDlg=new CDetailDlg(this);
	//Transmission pDoc vers bote de dialogue	
	m_pDetailDlg->Affecte(m_pDoc,1);//0:Air, 1::Lame. Pour faire la diffrence entre NbFr et NbFr1, ... 
}
//__________________________________________________
void CEpaisDlg::MetAJour()
{
	//Mettre  jour les paramtres dans bote de dialogue dtails
	m_pDetailDlg->MetAJour();
}
//__________________________________________________
void CEpaisDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	//Remise  jour aprs fermeture bote dtails
	m_fFrPart=m_pDoc->m_fFrPart;
	UpdateData(FALSE); 
	// Do not call CDialog::OnPaint() for painting messages
}
//__________________________________________________
void CEpaisDlg::OnOK() 
{
	//CDialog::OnOK();
}
