// tesandlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "tesandlg.h"
//#include "Eurosmartdx.h"
//#include "Candibusdx.h"
#include "Eurosmart.h"
#include "Candibus.h"

#include "bkdoc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CTestAnDlg dialog
CTestAnDlg::CTestAnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestAnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestAnDlg)
	m_s1 = _T("");
	m_s2 = _T("");
	//}}AFX_DATA_INIT
}
void CTestAnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestAnDlg)
	DDX_Control(pDX, IDACQUISITION, m_btnAcq);
	DDX_Control(pDX, IDSTOP, m_btnStop);
	DDX_Text(pDX, IDC_STATIC_CARTE, m_s1);
	DDX_Text(pDX, IDC_STATIC_TENSION, m_s2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CTestAnDlg, CDialog)
	//{{AFX_MSG_MAP(CTestAnDlg)
	ON_BN_CLICKED(IDACQUISITION, OnAcquisition)
	ON_BN_CLICKED(IDSTOP, OnStop)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
void CTestAnDlg::OnAcquisition()
{
	//Acquisition des tensions sur carte A/N slectionne
	//On valide/invalide les boutons
	m_btnStop.EnableWindow(TRUE);
	m_btnAcq.EnableWindow(FALSE);
	SetTimer(0,150,NULL);
}
//________________________________________
void CTestAnDlg::OnCancel()
{
	KillTimer(0);
	delete m_pEuro;
	delete m_pCand;
	CDialog::OnCancel();
}
//________________________________________
void CTestAnDlg::OnStop()
{
	KillTimer(0);
	//On valide/invalide les boutons
	m_btnStop.EnableWindow(FALSE);
	m_btnAcq.EnableWindow(TRUE);
}
//________________________________________
BOOL CTestAnDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	char c;
	m_pEuro=new CEurosmart();
	m_pCand=new CCandibus();
	//Invalider le bouton Stop
	m_btnStop.EnableWindow(FALSE);
	switch (m_pDoc->m_iTypeCarte)
	{
		case 0://Eurosmart
			if (m_pDoc->m_iTypePol[0]==1) c='B'; else c='U';
			m_s1.Format("Carte Eurosmart, voie %d%c.\nMoy. sur %d valeurs.",m_pDoc->m_iNoVoie[0],c,m_pDoc->m_iMoy[0]);
		break;
		case 1://Candibus
			m_s1.Format("Carte Candibus, voie %d.\nMoy. sur %d valeurs.",m_pDoc->m_iNoVoie[0],m_pDoc->m_iMoy[0]);
		break;
		default://Aucune
			m_s1.Format("Pas de carte A/N dtecte !");
			m_btnAcq.EnableWindow(FALSE);
		break;
	}
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CTestAnDlg::OnTimer(UINT nIDEvent)
{
	float u;
	char s[80];
	
	//On lit la tension sur la carte
	switch (m_pDoc->m_iTypeCarte)
	{
		case 0://Eurosmart
			u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[0],m_pDoc->m_iTypePol[0],m_pDoc->m_iMoy[0]);
		break;
		case 1://Candibus
			u=m_pCand->LitTension(m_pDoc->m_iNoVoie[0],m_pDoc->m_iMoy[0]);
		break;
		default://Aucune
			u=1e10;
		break;
	}
	if (u!=1e10)
	{
		m_s2.Format("U(V): %8.3f",u);
		//m_pDoc->m_bOKEuro=TRUE;
	}	
	else
	{
		m_s2.Format("U(V): ####.###");
		//m_pDoc->m_bOKEuro=FALSE;
	}	
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CTestAnDlg::OnOK() 
{
	//CDialog::OnOK();
}
