// tesprdlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "tesprdlg.h"   
#include "bkdoc.h"   
//#include "EurosmartDX.h"   
//#include "CandibusDX.h"   

#include "Eurosmart.h"
#include "Candibus.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CTesPrDlg dialog
CTesPrDlg::CTesPrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTesPrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTesPrDlg)
	m_s1 = _T("");
	m_s2 = _T("");
	//}}AFX_DATA_INIT
}
void CTesPrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTesPrDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDSTOP, m_btnStop);
	DDX_Control(pDX, IDACQUISITION, m_btnAcq);
	DDX_Text(pDX, IDC_STATIC_CARTE1, m_s1);
	DDX_Text(pDX, IDC_STATIC_PRESSION, m_s2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CTesPrDlg, CDialog)
	//{{AFX_MSG_MAP(CTesPrDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDACQUISITION, OnAcquisition)
	ON_BN_CLICKED(IDSTOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CTesPrDlg message handlers
BOOL CTesPrDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	char c;
	m_pEuro=new CEurosmart();
	m_pCand=new CCandibus();
	//Invalider le bouton Stop
	m_btnStop.EnableWindow(FALSE);
	switch (m_pDoc->m_iTypeCarte)
	{
		case 0://Eurosmart
			if (m_pDoc->m_iTypePol[1]==1) c='B'; else c='U';
			m_s1.Format("Carte Eurosmart, voie %d%c.\nMoy. sur %d valeurs.",m_pDoc->m_iNoVoie[1],c,m_pDoc->m_iMoy[1]);
		break;
		case 1://Candibus
			m_s1.Format("Carte Candibus, voie %d.\nMoy. sur %d valeurs.",m_pDoc->m_iNoVoie[1],m_pDoc->m_iMoy[1]);
		break;
		default://Aucune
			m_s1.Format("Pas de carte A/N dtecte !");
			m_btnAcq.EnableWindow(FALSE);
		break;
	}
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CTesPrDlg::OnTimer(UINT nIDEvent)
{
	float u;
	//On lit la tension sur la carte
	switch (m_pDoc->m_iTypeCarte)
	{
		case 0://Eurosmart
			u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iTypePol[1],m_pDoc->m_iMoy[1]);
		break;
		case 1://Candibus
			u=m_pCand->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iMoy[1]);
		break;
		default://Aucune
			u=1e10;
		break;
	}
	if (u!=1e10)
	{
		m_s2.Format("U(V): %8.3f",u);
		//m_pDoc->m_bOKEuro=TRUE;
	}	
	else
	{
		m_s2.Format("U(V): ####.###");
		//m_pDoc->m_bOKEuro=FALSE;
	}	
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CTesPrDlg::OnCancel()
{
	KillTimer(ID_TEST_TIMER1);
	delete m_pEuro;
	delete m_pCand;
	CDialog::OnCancel();
}
//________________________________________
void CTesPrDlg::OnAcquisition()
{
	//Acquisition des tensions sur carte A/N slectionne
	//On valide/invalide les boutons
	m_btnStop.EnableWindow(TRUE);
	m_btnAcq.EnableWindow(FALSE);
	//On lance le timer (dclar dans RESOURCE.H)
	SetTimer(ID_TEST_TIMER1,150,NULL);
}
//________________________________________
void CTesPrDlg::OnStop()
{
	KillTimer(ID_TEST_TIMER1);
	//On valide/invalide les boutons
	m_btnStop.EnableWindow(FALSE);
	m_btnAcq.EnableWindow(TRUE);
}
//________________________________________
void CTesPrDlg::OnOK() 
{
	//CDialog::OnOK();
}
