// airdlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "airdlg.h"
#include "bkdoc.h"
#include "bkview.h"
//#include "EurosmartDX.h"
//#include "CandibusDX.h"

#include "Eurosmart.h"
#include "Candibus.h"

#include <math.h>            

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAirDlg dialog
CAirDlg::CAirDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAirDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAirDlg)
	m_fLambda = 0;
	m_fLg = 0;
	m_iNb = 0;
	m_iNbFr = 0;
	m_fFrPart = 0;
	m_sP1 = "";
	m_sP2 = "";
	m_s = _T("");
	m_s2 = _T("");
	m_iTempo = 0;
	//}}AFX_DATA_INIT

	//A ajouter:
	Create(IDD_AIR,pParent);
}
void CAirDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAirDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, ID_STOP, m_btnStop);
	DDX_Control(pDX, ID_ACQ, m_btnAcq);
	DDX_Control(pDX, ID_CALC, m_btnCalc);
	DDX_Control(pDX, ID_FR, m_BtnFr);
	DDX_Text(pDX, IDC_LAMBDA, m_fLambda);
	DDX_Text(pDX, IDC_LG, m_fLg);
	DDX_Text(pDX, IDC_NB, m_iNb);
	DDX_Text(pDX, IDC_NB_FR, m_iNbFr);
	DDX_Text(pDX, IDC_NB_FR_PART, m_fFrPart);
	DDX_Text(pDX, IDC_P1, m_sP1);
	DDX_Text(pDX, IDC_P2, m_sP2);
	DDX_Text(pDX, IDC_STATIC_INFO, m_s);
	DDX_Text(pDX, IDC_STATIC1, m_s2);
	DDX_Text(pDX, IDC_NB2, m_iTempo);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAirDlg, CDialog)
	//{{AFX_MSG_MAP(CAirDlg)
	ON_BN_CLICKED(ID_CALC, OnCalcul)
	ON_EN_KILLFOCUS(IDC_LAMBDA, OnKillfocusLambda)
	ON_EN_KILLFOCUS(IDC_LG, OnKillfocusLg)
	ON_EN_KILLFOCUS(IDC_NB, OnKillfocusNb)
	ON_EN_KILLFOCUS(IDC_NB_FR, OnKillfocusNbFr)
	ON_EN_KILLFOCUS(IDC_P1, OnKillfocusP1)
	ON_EN_KILLFOCUS(IDC_P2, OnKillfocusP2)
	ON_BN_CLICKED(ID_ACQ, OnAcquisition)
	ON_BN_CLICKED(ID_STOP, OnStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(ID_FR, OnFranges)
	ON_EN_KILLFOCUS(IDC_NB_FR_PART, OnKillfocusNbFrPart)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CAirDlg message handlers
void CAirDlg::PostNcDestroy()
{
	delete this;
}
//________________________________________
BOOL CAirDlg::OnInitDialog()
{
	CDialog::OnInitDialog();  
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame-> GetActiveDocument();
	m_pEuro=new CEurosmart();
	m_pCand=new CCandibus();

	//Valeurs par dfaut
	m_fLg=m_pDoc->m_fLg;  
	//Dernires valeurs de pression
	m_fP2=m_pDoc->m_fP2;//Pression atmosphrique
	m_sP1.Format("%1.3f",m_pDoc->m_fP1);//Initiale
	m_sP2.Format("%1.3f",m_fP2);//Finale, pour l'instant atmosphrique
  
	m_fLambda=m_pDoc->m_fLambda;  
	m_iNb=m_pDoc->m_iNbPts;
  //Ajout le 12/09/04
  m_iTempo=m_pDoc->m_iTempo;
	m_iNbTimer=100/m_iTempo;
	m_s2.Format("(%d acq. toutes les 100 ms)",m_iNbTimer);
	//__________________
	m_iNbFr=m_pDoc->m_iNbFr;  
	//m_fFrPart=m_pDoc->m_fFrPart;  
	m_fFrPart=0;
	//On invalide  les boutons
	m_btnStop.EnableWindow(FALSE);                    
	if (m_pDoc->m_iNbA==0)
	{
		m_BtnFr.EnableWindow(FALSE); //Sur le graphe...
		m_btnStop.EnableWindow(FALSE);                    
	}	
	if (m_pDoc->m_iTypeCarte==-1)
	{
		m_s.Format("Carte A/N non dtecte !");
		m_btnAcq.EnableWindow(FALSE);
	}
	else
		m_s.Format("Indice de l'air: _.________\nCliquer sur Calculer ou faire une Acquisition...");
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CAirDlg::Affecte()
{
}
//________________________________________
void CAirDlg::OnCalcul()
{
	//Calcul de l'indice de l'air
	double n,k;
	//Rajout -1 le26/01/00
	k=(double)((1.013*(m_iNbFr-1+m_fFrPart)*m_fLambda)/((m_fP2-m_pDoc->m_fP1)*m_fLg));
	//n=k*760+1;
	n=1.0+k/1e6;
	if (fabs(m_fFrPart)<0.001) AfxMessageBox("Attention !\nA priori le nb. de franges partielles n'est pas nul...");
	m_s.Format("Avez-vous VERIFIE les valeurs nb. franges et frange partielle ?\nIndice de l'air: %9.7f\nCliquer sur Calculer ou faire une Acquisition...",n);
	UpdateData(FALSE);
}
//________________________________________
void CAirDlg::OnKillfocusLambda()
{
	UpdateData(TRUE);
	if (m_fLambda<100) m_fLambda=632.8;
	if (m_fLambda>1000) m_fLambda=632.8;
	m_pDoc->m_fLambda=m_fLambda;
	UpdateData(FALSE); 
}
//__________________________________________________
void CAirDlg::OnKillfocusLg()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_fLg<5) m_fLg=5;
	if (m_fLg>100) m_fLg=100;
	m_pDoc->m_fLg=m_fLg;
	UpdateData(FALSE); 
}
//__________________________________________________
void CAirDlg::OnKillfocusNb()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_iNb<64) m_iNb=64;
	if (m_iNb>m_pDoc->m_iNbAcq) m_iNb=m_pDoc->m_iNbAcq;
	m_pDoc->m_iNbPts=m_iNb;
	UpdateData(FALSE); 
}
//__________________________________________________
void CAirDlg::OnKillfocusNbFr()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_iNbFr<3) m_iNbFr=3;
	if (m_iNbFr>1000) m_iNbFr=1000;
	m_pDoc->m_iNbFr=m_iNbFr;
	UpdateData(FALSE); 
}
//________________________________________
void CAirDlg::OnKillfocusP1()
{
	int i;
	float r;
	
	UpdateData(TRUE);
	i=sscanf(m_sP1,"%f",&r);
	if (i==1 && r<800 && r>0)
	{
		m_pDoc->m_fP1=r;
	}
	m_sP1.Format("%1.3f",m_pDoc->m_fP1);
	UpdateData(FALSE); 
}
//________________________________________
void CAirDlg::OnKillfocusP2()
{
	int i;
	float r;
	
	UpdateData(TRUE);
	i=sscanf(m_sP2,"%f",&r);
	if (i==1 && r<800 && r>0)
	{
		//Pas de mise  jour de la pression finale...
		//m_pDoc->m_fP2=r;
		m_fP2=r;
	}	
	m_sP2.Format("%1.3f",m_fP2);
	UpdateData(FALSE); 
}
//________________________________________
void CAirDlg::OnKillfocusNbFrPart()
{
	//Modification du nombre de franges partielles
	UpdateData(TRUE);
	if (m_fFrPart<-1) m_fFrPart=-1;
	if (m_fFrPart>1) m_fFrPart=1;
	m_pDoc->m_fFrPart=m_fFrPart;
	UpdateData(FALSE); 
}
//________________________________________
void CAirDlg::OnAcquisition()
{
  //Initialisation tableau position des franges
	UpdateData(TRUE);
	if (m_iTempo>50) m_iTempo=50;
	if (m_iTempo<1) m_iTempo=1;
	m_iNbTimer=100/m_iTempo;
	m_s2.Format("(%d acq. toutes les 100 ms)",m_iNbTimer);
	UpdateData(FALSE);
	m_pDoc->m_iTempo=m_iTempo;  

  float u,p;
  int i,j; 

  for (i=0;i<100;i++)
  {
 		m_pDoc->m_iTfr[0][i]=9999;
  }          
  //Initialisation du tableau
  for (i=0;i<=1;i++)
  {
  	for (j=0;j<m_pDoc->m_iNbAcq;j++)
  	{
  		m_pDoc->m_fT[j][i]=1e10;
  	}
  } 
	//Acquisition d'un spectre via carte Eurosmart
	//On valide/invalide les boutons
	m_btnStop.EnableWindow(TRUE);
	m_btnAcq.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnCalc.EnableWindow(FALSE);

	m_pDoc->m_iNbA=0;                    
	m_pDoc->m_iTypeGr=0;
	m_pDoc->m_iAxe_abs=0;
	m_pDoc->m_iAxe_ord=2;
	float u1;
	switch (m_pDoc->m_iTypeCarte)
	{
		case 0://Eurosmart
			u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iTypePol[1],m_pDoc->m_iMoy[1]);
			//u1=m_pEuro->LitTension(m_pDoc->m_iNoVoie[0],m_pDoc->m_iTypePol[0],m_pDoc->m_iMoy[0]);
		break;
		case 1://Candibus
			u=m_pCand->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iMoy[1]);
			//On lit une deuxime fois, la premire fois c'est faux...
			u=m_pCand->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iMoy[1]);
		break;
		default://Aucune
			u=1e10;
		break;
	}
	p=m_pDoc->m_faP*u+m_pDoc->m_fbP;
	//La pression initiale est affecte dans le timer...
	//m_pDoc->m_fP1=p;
	//m_sP1.Format("%1.3f",p);
	//? dans pression finale P2
	m_sP1="?";//Initiale
	m_sP2="?";//Finale
	UpdateData(FALSE);
	m_OKBusy=FALSE;SetTimer(0,100,NULL);
	// Demande de sauvegarde  la sortie
	m_pDoc->SetModifiedFlag();
}
//________________________________________
void CAirDlg::OnStop()
{
	//Arrt de l'acquisition en cours
	float u;
	//On valide/invalide  les boutons
	m_btnStop.EnableWindow(FALSE);
	m_btnAcq.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);
	m_btnCalc.EnableWindow(TRUE);
	if (m_pDoc->m_iNbA>0) 
	{
		m_BtnFr.EnableWindow(TRUE); //Sur le graphe...
		//m_btnDetail.EnableWindow(TRUE);
	}	
	//On dsire arrter l'acquisition d'un spectre
	KillTimer(0);
	m_s.Format("Acquisition arrte par l'utilisateur...\n(%d valeurs)",m_pDoc->m_iNbA);
	UpdateData(FALSE);
	m_pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CAirDlg::OnTimer(UINT nIDEvent)
{
	float u,u1,p;                        
	short i;
	if (m_OKBusy==FALSE)
	{
		m_OKBusy=TRUE;
		for (i=0;i<m_iNbTimer;i++)
		{
			if (m_pDoc->m_iNbA==0)
			{
				//Pression initiale
				switch (m_pDoc->m_iTypeCarte)
				{
					case 0://Eurosmart
						u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iTypePol[1],m_pDoc->m_iMoy[1]);
						u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iTypePol[1],m_pDoc->m_iMoy[1]);
						u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iTypePol[1],m_pDoc->m_iMoy[1]);
					break;
					case 1://Candibus
						u=m_pCand->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iMoy[1]);
					break;
					default://Aucune
						u=1e10;
					break;
				}
				p=m_pDoc->m_faP*u+m_pDoc->m_fbP;
				m_pDoc->m_fP1=p;
				if (u!=1e10)
					m_sP1.Format("%1.3f",p);//Pression initiale (vide)
				else
					m_sP1.Format("?");  
			}
			else
			{
				//Mesure de la pression courante
				switch (m_pDoc->m_iTypeCarte)
				{
					case 0://Eurosmart
						u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iTypePol[1],m_pDoc->m_iMoy[1]);
						u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iTypePol[1],m_pDoc->m_iMoy[1]);
						u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iTypePol[1],m_pDoc->m_iMoy[1]);
						u=m_pEuro->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iTypePol[1],m_pDoc->m_iMoy[1]);
					break;
					case 1://Candibus
						u=m_pCand->LitTension(m_pDoc->m_iNoVoie[1],m_pDoc->m_iMoy[1]);
					break;
					default://Aucune
						u=1e10;
					break;
				}
				m_fP2=m_pDoc->m_faP*u+m_pDoc->m_fbP;
				//m_pDoc->m_fP2=m_fP2;
				if (u!=1e10)
				{
					//m_pDoc->m_fP2=p;
					m_sP2.Format("%1.3f",m_fP2);//Pression courante
				}
				else
				{
					m_sP2.Format("?");  
				}
			}
			if (m_pDoc->m_iNbA<m_iNb)
			{
				//Franges
				switch (m_pDoc->m_iTypeCarte)
				{
					case 0://Eurosmart
						u1=m_pEuro->LitTension(m_pDoc->m_iNoVoie[0],m_pDoc->m_iTypePol[0],m_pDoc->m_iMoy[0]);
					break;
					case 1://Candibus
						u1=m_pCand->LitTension(m_pDoc->m_iNoVoie[0],m_pDoc->m_iMoy[0]);
					break;
					default://Aucune
						u1=1e10;
					break;
				}
				if (u1!=1e10 && u!=1e10)
				{
					m_s.Format("%d/%d\nU(V): %8.3f\nU(V):%8.3f",m_pDoc->m_iNbA,m_iNb,u1,u);
				}	
				else
					m_s.Format("%d/%d\nU(V): ?",m_pDoc->m_iNbA,m_iNb);
				UpdateData(FALSE);

				//Affectation
				m_pDoc->m_fT[m_pDoc->m_iNbA][0]=m_pDoc->m_iNbA;	
				m_pDoc->m_fT[m_pDoc->m_iNbA][1]=u1;
				m_pDoc->m_iNbA++;
				Sleep(m_iTempo);
			} 
			else
			{
				//Fin de l'acquisition
				i=m_iNbTimer;
				KillTimer(0);
				//On valide/invalide  les boutons
				if (m_pDoc->m_iNbA>0) 
				{
					m_BtnFr.EnableWindow(TRUE); //Sur le graphe...
					//m_btnDetail.EnableWindow(TRUE);
				}
				m_btnStop.EnableWindow(FALSE);
				m_btnAcq.EnableWindow(TRUE);
				m_btnCancel.EnableWindow(TRUE);
				m_btnCalc.EnableWindow(TRUE);
				m_s.Format("Fin d'acquisition.\n(%d/%d)",m_pDoc->m_iNbA,m_iNb);
				m_pDoc->UpdateAllViews(NULL);
			}
			UpdateData(FALSE);
		}
		m_OKBusy=FALSE;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CAirDlg::OnCancel()
{
	//On dsire quitter la boite de dialogue
	delete m_pEuro;
	delete m_pCand;
	CFrameWnd *pFrame=(CFrameWnd *) (AfxGetApp()->m_pMainWnd);
	CBkView *pView=(CBkView*)pFrame-> GetActiveView();
	pView->m_pAirDlg=NULL;
	CDialog::OnCancel();
}
//________________________________________
void CAirDlg::OnFranges()
{
	//Clic sur Graphe pour dcoder l'acquisition
	//m_pDoc->m_iTypeGr=0;;
	m_pDoc->CalculFranges(0);
	m_iNbFr=m_pDoc->m_iNbFr;
  m_fFrPart=m_pDoc->m_fFrPart;	
	UpdateData(FALSE);	
	//Visualisation de la position des franges par des cercles -> non, car franges partielles
	m_pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CAirDlg::MetAJour()
{
	//Mettre  jour les paramtres dans bote de dialogue dtails


}
//________________________________________
void CAirDlg::OnOK() 
{
	OnCalcul();
	//CDialog::OnOK();
}
