// bkview.h : interface of the CBkView class
//
/////////////////////////////////////////////////////////////////////////////
//Botes de dialogues non modales
class CBkView : public CView
{
protected: // create from serialization only
	CBkView();
	DECLARE_DYNCREATE(CBkView)

// Attributes
public:
	CBkDoc* GetDocument();
	class CSourisDlg* m_pSouDlg;
	class CDmcDlg* m_pDmcDlg;
	class CAirDlg* m_pAirDlg;
	class CEpaisLDlg* m_pEpaisDlg;
	struct para
	{
		int n;
		float (*fT)[4];	
		char abs[80],ord[80],titre[80]; 
		int axe_abs,axe_ord;
		float xmi,ymi,xma,yma,xori,yori,factx,facty,echx,echy;
	};

// Operations
public:
	float Fenetre(CDC* pDC,float f_xmi,float f_ymi,float f_xma, float f_yma);
	float FenetreImp(CDC* pDC,float f_xmi,float f_ymi,float f_xma, float f_yma);

// Implementation
public:
	virtual ~CBkView();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Printing support
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Generated message map functions
protected:
	//{{AFX_MSG(CBkView)
	afx_msg void OnAffichSouris();
	afx_msg void OnUpdateAffichSouris(CCmdUI* pCmdUI);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTxtExcel();
	afx_msg void OnUpdateTxtExcel(CCmdUI* pCmdUI);
	afx_msg void OnFileNew();
	afx_msg void OnInfoAcq();
	afx_msg void OnDimensionsFenetre();
	afx_msg void OnDmc();
	afx_msg void OnUpdateDmc(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnCarteAnPara();
	afx_msg void OnAnTest();
	afx_msg void OnMotorisationDepManu();
	afx_msg void OnMotorisationTest();
	afx_msg void OnMesIndiceAir();
	afx_msg void OnTypeGraphe();
	afx_msg void OnMesIndEpais();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnPresParam();
	afx_msg void OnAcqPressionTest();
	afx_msg void OnUpdateMesIndEpais(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMesIndiceAir(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMotorisationDepManu(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMotorisationTest(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG	// debug version in bkview.cpp
inline CBkDoc* CBkView::GetDocument()
   { return (CBkDoc*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
class CDessin
{
	public:
		CDessin(CDC *pDC,float f_ech);
		~CDessin();
  
  //Attributes     
  protected:
  	float m_ech;      
  	CDC* m_pDC;  
  	//CPen *m_pOldPen;
  	//CFont *m_pOldFont;      
	public:
  	float m_fHautTexte;
		typedef float Tfloat[4];
		struct para
		{
			int n;
			Tfloat *fT;	
			char abs[80],ord[80],titre[80];
			int axe_abs,axe_ord;
			float xmi,ymi,xma,yma,xori,yori,factx,facty,echx,echy;
		};
  	//Fonctions de trac
		void cadre(float f_xg,float f_yb,float f_xd,float f_yh);
		void ligne(float f_xd,float f_yd,float f_xa,float f_ya);
		void cercle(float f_xc,float f_yc,float f_ray);
		void fleche(float f_xp,float f_yp,float f_a,float f_l);
		void texte(float f_x,float f_y,char *s);
		void ecritInfo(float f_x,float f_y,CStringArray *p_sTab,float f_taille,long coul);
  	//Fonction de trac graphique
		char Graphe3(struct para *p);
		//Trac de la droite de rgression linaire
		void TraceDMC(int no,float a,float b,para p);
		void TraceMarqPoint(int no,float xp1,float yp1,float xp2,float yp2,para p);
		//Gomtrie analytique
		void p2d(double xd1,double yd1,double a1,double xd2,double yd2,double a2,double *p_x,double *p_y);
};
