// presdlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "presdlg.h"   
#include "bkdoc.h"   
//#include "EurosmartDX.h"
//#include "CandibusDX.h"

#include "Eurosmart.h"
#include "Candibus.h"

#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CPresDlg dialog
CPresDlg::CPresDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPresDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPresDlg)
	m_faP = 0;
	m_fbP = 0;
	m_iMoy = 0;
	m_radioPol = -1;
	m_radioVoie = -1;
	m_fP2 = 0.0f;
	m_s1 = _T("");
	//}}AFX_DATA_INIT
}
void CPresDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPresDlg)
	DDX_Text(pDX, IDC_AP, m_faP);
	DDX_Text(pDX, IDC_BP, m_fbP);
	DDX_Text(pDX, IDC_MOY, m_iMoy);
	DDX_Radio(pDX, IDC_UNIPOLAIRE, m_radioPol);
	DDX_Radio(pDX, IDC_VOIE0, m_radioVoie);
	DDX_Text(pDX, IDC_PR, m_fP2);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPresDlg, CDialog)
	//{{AFX_MSG_MAP(CPresDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CPresDlg message handlers
BOOL CPresDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_pEuro=new CEurosmart();
	m_pCand=new CCandibus();

	m_fP2=m_pDoc->m_fP2;
	m_faP=m_pDoc->m_faP;
	m_fbP=m_pDoc->m_fbP;
	m_iMoy=m_pDoc->m_iMoy[1];
	m_radioPol=m_pDoc->m_iTypePol[1];
	m_radioVoie=m_pDoc->m_iNoVoie[1];
	switch (m_pDoc->m_iTypeCarte)
	{
		case 0://Eurosmart
		break;
		case 1://Candibus
			GetDlgItem(IDC_UNIPOLAIRE)->EnableWindow(FALSE);	
		break;
		default://Pas de carte
			GetDlgItem(IDC_UNIPOLAIRE)->EnableWindow(FALSE);	
			GetDlgItem(IDC_BIPOLAIRE)->EnableWindow(FALSE);	
			GetDlgItem(IDC_VOIE0)->EnableWindow(FALSE);	
			GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);	
		break;
	}
	UpdateData(FALSE);
	//Calculer
	OnOK();
	return TRUE;
}
//________________________________________
void CPresDlg::OnOK()
{
	float u2;
	//Calculer
	UpdateData(TRUE);
	if (m_iMoy<=0) m_iMoy=1;
	if (m_iMoy>1024) m_iMoy=1024;
	if (fabs(m_faP)<0.01) m_faP=m_pDoc->m_faP;
	if (m_fP2<0.800) m_fP2=0.800;
	if (m_fP2>1.200) m_fP2=1.200;
	switch (m_pDoc->m_iTypeCarte)
	{
		case 0://Eurosmart
			u2=m_pEuro->LitTension(m_radioVoie,m_radioPol,m_iMoy);
		break;
		case 1://Candibus
			u2=m_pCand->LitTension(m_radioVoie,m_iMoy);
		break;
		default:
			u2=1e10;
		break;
	}
	if (u2==1e10)
	{
		//u2=(m_fP2-m_fbP)/m_faP;
		m_s1.Format("(?)");
	}
	else
	{
		m_s1.Format("(%1.2f V)",u2);
		//On calcule m_fbP
		m_fbP=m_fP2-m_faP*u2;
	}
	UpdateData(FALSE);
	//CDialog::OnOK();
}
//________________________________________
void CPresDlg::OnCancel() 
{
	//Calculer
	OnOK();
	delete m_pEuro;
	delete m_pCand;

	m_pDoc->m_fP2=m_fP2;
	m_pDoc->m_faP=m_faP;
	m_pDoc->m_fbP=m_fbP;
	m_pDoc->m_iTypePol[1]=m_radioPol;
	m_pDoc->m_iNoVoie[1]=m_radioVoie;   
  //Les deux mmes voies d'acquisition
	if (m_pDoc->m_iNoVoie[1]==m_pDoc->m_iNoVoie[0])
		AfxMessageBox("Attention: conflit de voie d'acquisition A/N !");
	
	CDialog::OnCancel();
}
