// CandibusDX.cpp : implementation file
//________________________________________
#include "stdafx.h"
#include "Bk.h"
#include "CandibusDX.h"
#include "DxClass.h"
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CCandibusDX
CCandibusDX::CCandibusDX()
{
	ADR1=0x280;          
	ADR2=0x282;          
	STATUS=0x284;
	if (GetVersion() & 0x80000000)
	{
		//W98, pas de connexion  Driver X
		m_OKConnect=TRUE;
	}
	else
	{
		//Connexion DriverX
		m_pCandi=new CDevice();
		if (!m_pCandi->ConnectDevice("candibus"))
		{
			AfxMessageBox("Erreur de connexion  DriverX !\n\nParamtres de connexion:\nDevice: candibus\nBus Type: ISA\nUses port range\nPort Base: 0X280\nPort Count: 0X4\nIgnore ressource conflicts");
			m_OKConnect=FALSE;
		}
		else
		{
			CDeviceConfig config;
			m_pCandi->GetDeviceConfig("candibus",&config);
			config.bIgnoreConflicts=TRUE;
			m_pCandi->ConfigureDevice("candibus",config);
			m_OKConnect=TRUE;
		}
	}
	//Test prsence carte
	float r;
	unsigned char c,c1,c2;
	double duree;
	clock_t t1,t2;
	if(m_OKConnect)
	{
		if (GetVersion() & 0x80000000)
		{
			//W98
			r=readad(0);
			if (r==1e10)
				m_OKCarte=FALSE;
			else
				m_OKCarte=TRUE;
		}
		else
		{
			//Sous W2000, toujours des valeurs retournes  cause de DriverX...
			out_port(ADR1,0xFF);
			t1=clock();
			do
			{
				t2=clock();
				duree=(double)(t2-t1)/CLOCKS_PER_SEC;	//Dure en secondes
				c=in_port(STATUS);
			}
			while((c&1) && duree<0.1);
			c1=in_port(ADR1);
			c2=in_port(ADR1+1);
			//CString s;s.Format("c:%d, c1%d, c2:%d",c,c1,c2);AfxMessageBox(s);
			if (c==0 && c1==255 && c2==255)
				m_OKCarte=FALSE;
			else
				m_OKCarte=TRUE;
		}
	}
	else
		m_OKCarte=FALSE;
}
//________________________________________
CCandibusDX::~CCandibusDX()
{
	if (GetVersion() & 0x80000000)
	{
		//W98, pas de dconnexion  Driver X
	}
	else
	{
		m_pCandi->DisconnectDevice();
		delete m_pCandi;
	}
}
//________________________________________
BEGIN_MESSAGE_MAP(CCandibusDX, CWnd)
	//{{AFX_MSG_MAP(CCandibusDX)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CCandibusDX message handlers
BOOL CCandibusDX::Connect(void)
{
	return m_OKConnect;
}
//________________________________________
BOOL CCandibusDX::OKCarte(void)
{
	return m_OKCarte;
}
//________________________________________
void CCandibusDX::out_port(long a,unsigned char c)
{
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		//Registre de donnes: Offset+0: criture de l'octet
		_outp(a,c);
	}
	else
	{
		//DriverX pour XP
		m_pCandi->outp(a-ADR1,c);
	}
}
//________________________________________
unsigned char CCandibusDX::in_port(long a)
{
	unsigned char k;
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		k=_inp(a);
	}
	else
	{
		//DriverX pour XP : enlever l'adresse de base
		k=m_pCandi->inp(a-ADR1);
	}
	return k;
}
//________________________________________
float CCandibusDX::readad(int NoVoie)
{
	float
		mesure1,mesure2;
	unsigned long i;	
	float r;
	double duree;
	clock_t t1,t2;

	switch(NoVoie)
	{
		case 0:
			out_port(ADR1,0xFF);
			t1=clock();
			do
			{
				t2=clock();
				duree=(double)(t2-t1)/CLOCKS_PER_SEC;	//Dure en secondes
			}
			while((in_port(STATUS)&1) && duree<0.1);
			if (duree<0.1)
			{
				//On dcale de 4 bits (voir notice page 6.4)
				mesure1=(float)(in_port(ADR1)<<4);
				mesure2=(float)(in_port(ADR1+1)>>4);
				r=(float)(10.24*(mesure1+mesure2-2047.5)/4094.0);
			}
			else
				r=1e10;
		break;
		case 1:
			out_port(ADR2,0xFF);
			t1=clock();
			do
			{
				t2=clock();
				duree=(double)(t2-t1)/CLOCKS_PER_SEC;
			}
			while((in_port(STATUS)&2) && duree<0.1);
			if (duree<0.1)
			{
				mesure1=(float)(in_port(ADR2)<<4);
				mesure2=(float)(in_port(ADR2+1)>>4);
				r=(float)(10.24*(mesure1+mesure2-2047.5)/4094.0);
			}
			else
				r=1e10;
		break;
	}
	return r;
}
//________________________________________
float CCandibusDX::LitTension(int NoVoie,int Nb)
{                                             
	int i,k;
	float r,r1;
	k=0;        
	r1=0;
	if (m_OKCarte)
	{
		for (i=0;i<Nb;i++)
		{   
			r=readad(NoVoie);
			if (r!=1e10)
			{       
				r1=r1+r;
				k++;
			}     
		}
		if (k>=1) return r1/k; else return 1e10;
	}
	else
		return 1e10;
}
//________________________________________
